import{s as At,o as qt,n as Nt}from"../chunks/scheduler.c57aa7ef.js";import{S as St,i as Wt,g as n,s as a,r as m,A as Ft,h as s,f as o,c as r,j as y,u as f,x as p,k as x,y as t,a as v,v as g,d as h,t as _,w as b}from"../chunks/index.c50cb18e.js";import{D as B}from"../chunks/Docstring.66f18243.js";import{C as Zt}from"../chunks/CodeBlock.34f0a53d.js";import{E as Qt}from"../chunks/ExampleCodeBlock.b5ddd071.js";import{H as ht,E as Gt}from"../chunks/EditOnGithub.958a8a49.js";function zt(Le){let u,k;return u=new Zt({props:{code:"Zm9yJTIwbmFtZSUyQyUyMHBhcmFtJTIwaW4lMjBtb2RlbF9wZWZ0Lm5hbWVkX3BhcmFtZXRlcnMoKSUzQSUwQSUyMCUyMCUyMCUyMGlmJTIwLi4uJTNBJTIwJTIwJTIzJTIwc29tZSUyMGNoZWNrJTIwb24lMjBuYW1lJTIwKGV4LiUyMGlmJTIwJ2xvcmEnJTIwaW4lMjBuYW1lKSUwQSUyMCUyMCUyMCUyMCUyMCUyMCUyMCUyMHBhcmFtLnJlcXVpcmVzX2dyYWQlMjAlM0QlMjBGYWxzZQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> name, param <span class="hljs-keyword">in</span> model_peft.named_parameters():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> ...:  <span class="hljs-comment"># some check on name (ex. if &#x27;lora&#x27; in name)</span>
<span class="hljs-meta">... </span>        param.requires_grad = <span class="hljs-literal">False</span>`,wrap:!1}}),{c(){m(u.$$.fragment)},l($){f(u.$$.fragment,$)},m($,ee){g(u,$,ee),k=!0},p:Nt,i($){k||(h(u.$$.fragment,$),k=!0)},o($){_(u.$$.fragment,$),k=!1},d($){b(u,$)}}}function Rt(Le){let u,k,$,ee,J,Me,A,_t="A tuner (or adapter) is a module that can be plugged into a <code>torch.nn.Module</code>. <code>BaseTuner</code> base class for other tuners and provides shared methods and attributes for preparing an adapter configuration and replacing a target module with the adapter module. <code>BaseTunerLayer</code> is a base class for adapter layers. It offers methods and attributes for managing adapters such as activating and disabling adapters.",Pe,q,je,l,N,Ae,te,bt=`A base tuner model that provides the common methods and attributes for all tuners that are injectable into a
torch.nn.Module`,qe,ae,$t="For adding a new Tuner class, one needs to overwrite the following methods:",Ne,re,vt=`<li><strong>_prepare_adapter_config</strong>:
A private method to eventually prepare the adapter config, for example in case the field <code>target_modules</code> is
missing.</li> <li><strong>_create_and_replace</strong>:
A private method to create and replace the target module with the adapter module.</li> <li><strong>_check_target_module_exists</strong>:
A private helper method to check if the passed module’s key name matches any of the target modules in the
adapter_config.</li>`,Se,ne,yt="The easiest is to check what is done in the <code>peft.tuners.lora.LoraModel</code> class.",We,I,S,Fe,se,xt="Disable all adapters in-place.",Ze,D,W,Qe,oe,Tt="Enable all adapters in-place",Ge,L,F,ze,le,wt=`Creates adapter layers and replaces the target modules with the adapter layers. This method is called under the
hood by <code>peft.mapping.get_peft_model</code> if a non-prompt tuning adapter class is passed.`,Re,de,Ct="The corresponding PEFT config is directly retrieved from the <code>peft_config</code> attribute of the BaseTuner class.",Xe,M,Z,Ye,ie,Bt="This method merges the adapter layers into the base model.",Ke,pe,Lt=`Merging adapters can lead to a speed up of the forward pass. A copy of the adapter weights is still kept in
memory, which is required to unmerge the adapters. In order to merge the adapter weights without keeping them
in memory, please call <code>merge_and_unload</code>.`,Oe,U,Q,et,ue,Mt="This method unmerges all merged adapter layers from the base model.",ke,G,Ie,c,z,tt,ce,Pt="A tuner layer mixin that provides the common methods and attributes for all tuners.",at,T,R,rt,me,jt="Delete an adapter from the layer",nt,fe,kt="This should be called on all adapter layers, or else we will get an inconsistent state.",st,ge,It=`This method will also set a new active adapter if the deleted adapter was an active adapter. It is important
that the new adapter is chosen in a deterministic way, so that the same adapter is chosen on all layers.`,ot,P,X,lt,he,Dt="Toggle the enabling and disabling of adapters",dt,_e,Ut="Takes care of setting the requires_grad flag for the adapter weights.",it,j,Y,pt,be,Et="(Recursively) get the base_layer.",ut,$e,Ht="This is necessary for the case that the tuner layer wraps another tuner layer.",ct,w,K,mt,ve,Vt="Set the active adapter(s).",ft,ye,Jt=`Additionally, this function will set the specified adapters to trainable (i.e., requires_grad=True). If this is
not desired, use the following code.`,gt,E,De,O,Ue,Be,Ee;return J=new ht({props:{title:"Tuners",local:"tuners",headingTag:"h1"}}),q=new ht({props:{title:"BaseTuner",local:"peft.tuners.tuners_utils.BaseTuner",headingTag:"h2"}}),N=new B({props:{name:"class peft.tuners.tuners_utils.BaseTuner",anchor:"peft.tuners.tuners_utils.BaseTuner",parameters:[{name:"model",val:""},{name:"peft_config",val:": Union[PeftConfig, dict[str, PeftConfig]]"},{name:"adapter_name",val:": str"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTuner.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to which the adapter tuner layers will be attached.`,name:"model"},{anchor:"peft.tuners.tuners_utils.BaseTuner.forward",description:`<strong>forward</strong> (<code>Callable</code>) &#x2014;
The forward method of the model.`,name:"forward"},{anchor:"peft.tuners.tuners_utils.BaseTuner.peft_config",description:`<strong>peft_config</strong> (<code>Union[</code>PeftConfig<code>, dict[str, PeftConfig]]</code>) &#x2014;
The adapter configuration object, it should be a dictionary of <code>str</code> to <code>PeftConfig</code> objects. One can also
pass a PeftConfig object and a new adapter will be created with the default name <code>adapter</code> or create a new
dictionary with a key <code>adapter_name</code> and a value of that peft config.`,name:"peft_config"},{anchor:"peft.tuners.tuners_utils.BaseTuner.config",description:`<strong>config</strong> (<code>dict[str, Any]</code>) &#x2014;
The model configuration object, it should be a dictionary of <code>str</code> to <code>Any</code> objects.`,name:"config"},{anchor:"peft.tuners.tuners_utils.BaseTuner.targeted_module_names",description:`<strong>targeted_module_names</strong> (<code>list[str]</code>) &#x2014;
The list of module names that were actually adapted. Can be useful to inspect if you want to quickly
double-check that the <code>config.target_modules</code> were specified correctly.`,name:"targeted_module_names"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L109"}}),S=new B({props:{name:"disable_adapter_layers",anchor:"peft.tuners.tuners_utils.BaseTuner.disable_adapter_layers",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L284"}}),W=new B({props:{name:"enable_adapter_layers",anchor:"peft.tuners.tuners_utils.BaseTuner.enable_adapter_layers",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L291"}}),F=new B({props:{name:"inject_adapter",anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter",parameters:[{name:"model",val:": nn.Module"},{name:"adapter_name",val:": str"},{name:"autocast_adapter_dtype",val:": bool = True"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter.model",description:`<strong>model</strong> (<code>nn.Module</code>) &#x2014;
The model to be tuned.`,name:"model"},{anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter.adapter_name",description:`<strong>adapter_name</strong> (<code>str</code>) &#x2014;
The adapter name.`,name:"adapter_name"},{anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter.autocast_adapter_dtype",description:`<strong>autocast_adapter_dtype</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to autocast the adapter dtype. Defaults to <code>True</code>.`,name:"autocast_adapter_dtype"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L352"}}),Z=new B({props:{name:"merge_adapter",anchor:"peft.tuners.tuners_utils.BaseTuner.merge_adapter",parameters:[{name:"adapter_names",val:": Optional[list[str]] = None"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTuner.merge_adapter.safe_merge",description:`<strong>safe_merge</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If <code>True</code>, the merge operation will be performed in a copy of the original weights and check for NaNs
before merging the weights. This is useful if you want to check if the merge operation will produce
NaNs. Defaults to <code>False</code>.`,name:"safe_merge"},{anchor:"peft.tuners.tuners_utils.BaseTuner.merge_adapter.adapter_names",description:`<strong>adapter_names</strong> (<code>list[str]</code>, <em>optional</em>) &#x2014;
The list of adapter names that should be merged. If <code>None</code>, all active adapters will be merged.
Defaults to <code>None</code>.`,name:"adapter_names"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L437"}}),Q=new B({props:{name:"unmerge_adapter",anchor:"peft.tuners.tuners_utils.BaseTuner.unmerge_adapter",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L460"}}),G=new ht({props:{title:"BaseTunerLayer",local:"peft.tuners.tuners_utils.BaseTunerLayer",headingTag:"h2"}}),z=new B({props:{name:"class peft.tuners.tuners_utils.BaseTunerLayer",anchor:"peft.tuners.tuners_utils.BaseTunerLayer",parameters:[],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.is_pluggable",description:`<strong>is_pluggable</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether the adapter layer can be plugged to any pytorch module`,name:"is_pluggable"},{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.active_adapters",description:`<strong>active_adapters</strong> (Union[List<code>str</code>, <code>str</code>], <em>optional</em>) &#x2014;
The name of the active adapter.`,name:"active_adapters"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L478"}}),R=new B({props:{name:"delete_adapter",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.delete_adapter",parameters:[{name:"adapter_name",val:": str"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.delete_adapter.adapter_name",description:"<strong>adapter_name</strong> (<code>str</code>) &#x2014; The name of the adapter to delete",name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L635"}}),X=new B({props:{name:"enable_adapters",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.enable_adapters",parameters:[{name:"enabled",val:": bool"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.enable_adapters.enabled",description:"<strong>enabled</strong> (bool) &#x2014; True to enable adapters, False to disable adapters",name:"enabled"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L575"}}),Y=new B({props:{name:"get_base_layer",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.get_base_layer",parameters:[],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L505"}}),K=new B({props:{name:"set_adapter",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.set_adapter",parameters:[{name:"adapter_names",val:": str | list[str]"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.set_adapter.adapter_name",description:"<strong>adapter_name</strong> (<code>str</code> or <code>List[str]</code>) &#x2014; Name of the adapter(s) to be activated.",name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/tuners_utils.py#L593"}}),E=new Qt({props:{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.set_adapter.example",$$slots:{default:[zt]},$$scope:{ctx:Le}}}),O=new Gt({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/package_reference/tuners.md"}}),{c(){u=n("meta"),k=a(),$=n("p"),ee=a(),m(J.$$.fragment),Me=a(),A=n("p"),A.innerHTML=_t,Pe=a(),m(q.$$.fragment),je=a(),l=n("div"),m(N.$$.fragment),Ae=a(),te=n("p"),te.textContent=bt,qe=a(),ae=n("p"),ae.textContent=$t,Ne=a(),re=n("ul"),re.innerHTML=vt,Se=a(),ne=n("p"),ne.innerHTML=yt,We=a(),I=n("div"),m(S.$$.fragment),Fe=a(),se=n("p"),se.textContent=xt,Ze=a(),D=n("div"),m(W.$$.fragment),Qe=a(),oe=n("p"),oe.textContent=Tt,Ge=a(),L=n("div"),m(F.$$.fragment),ze=a(),le=n("p"),le.innerHTML=wt,Re=a(),de=n("p"),de.innerHTML=Ct,Xe=a(),M=n("div"),m(Z.$$.fragment),Ye=a(),ie=n("p"),ie.textContent=Bt,Ke=a(),pe=n("p"),pe.innerHTML=Lt,Oe=a(),U=n("div"),m(Q.$$.fragment),et=a(),ue=n("p"),ue.textContent=Mt,ke=a(),m(G.$$.fragment),Ie=a(),c=n("div"),m(z.$$.fragment),tt=a(),ce=n("p"),ce.textContent=Pt,at=a(),T=n("div"),m(R.$$.fragment),rt=a(),me=n("p"),me.textContent=jt,nt=a(),fe=n("p"),fe.textContent=kt,st=a(),ge=n("p"),ge.textContent=It,ot=a(),P=n("div"),m(X.$$.fragment),lt=a(),he=n("p"),he.textContent=Dt,dt=a(),_e=n("p"),_e.textContent=Ut,it=a(),j=n("div"),m(Y.$$.fragment),pt=a(),be=n("p"),be.textContent=Et,ut=a(),$e=n("p"),$e.textContent=Ht,ct=a(),w=n("div"),m(K.$$.fragment),mt=a(),ve=n("p"),ve.textContent=Vt,ft=a(),ye=n("p"),ye.textContent=Jt,gt=a(),m(E.$$.fragment),De=a(),m(O.$$.fragment),Ue=a(),Be=n("p"),this.h()},l(e){const d=Ft("svelte-u9bgzb",document.head);u=s(d,"META",{name:!0,content:!0}),d.forEach(o),k=r(e),$=s(e,"P",{}),y($).forEach(o),ee=r(e),f(J.$$.fragment,e),Me=r(e),A=s(e,"P",{"data-svelte-h":!0}),p(A)!=="svelte-dsnslo"&&(A.innerHTML=_t),Pe=r(e),f(q.$$.fragment,e),je=r(e),l=s(e,"DIV",{class:!0});var i=y(l);f(N.$$.fragment,i),Ae=r(i),te=s(i,"P",{"data-svelte-h":!0}),p(te)!=="svelte-1k0hvlq"&&(te.textContent=bt),qe=r(i),ae=s(i,"P",{"data-svelte-h":!0}),p(ae)!=="svelte-fkgwsm"&&(ae.textContent=$t),Ne=r(i),re=s(i,"UL",{"data-svelte-h":!0}),p(re)!=="svelte-uumdnf"&&(re.innerHTML=vt),Se=r(i),ne=s(i,"P",{"data-svelte-h":!0}),p(ne)!=="svelte-1sc4mfu"&&(ne.innerHTML=yt),We=r(i),I=s(i,"DIV",{class:!0});var He=y(I);f(S.$$.fragment,He),Fe=r(He),se=s(He,"P",{"data-svelte-h":!0}),p(se)!=="svelte-1hrol74"&&(se.textContent=xt),He.forEach(o),Ze=r(i),D=s(i,"DIV",{class:!0});var Ve=y(D);f(W.$$.fragment,Ve),Qe=r(Ve),oe=s(Ve,"P",{"data-svelte-h":!0}),p(oe)!=="svelte-1l6xdbj"&&(oe.textContent=Tt),Ve.forEach(o),Ge=r(i),L=s(i,"DIV",{class:!0});var xe=y(L);f(F.$$.fragment,xe),ze=r(xe),le=s(xe,"P",{"data-svelte-h":!0}),p(le)!=="svelte-1ybn6sj"&&(le.innerHTML=wt),Re=r(xe),de=s(xe,"P",{"data-svelte-h":!0}),p(de)!=="svelte-fvf2kw"&&(de.innerHTML=Ct),xe.forEach(o),Xe=r(i),M=s(i,"DIV",{class:!0});var Te=y(M);f(Z.$$.fragment,Te),Ye=r(Te),ie=s(Te,"P",{"data-svelte-h":!0}),p(ie)!=="svelte-kun7ud"&&(ie.textContent=Bt),Ke=r(Te),pe=s(Te,"P",{"data-svelte-h":!0}),p(pe)!=="svelte-1f1s101"&&(pe.innerHTML=Lt),Te.forEach(o),Oe=r(i),U=s(i,"DIV",{class:!0});var Je=y(U);f(Q.$$.fragment,Je),et=r(Je),ue=s(Je,"P",{"data-svelte-h":!0}),p(ue)!=="svelte-2eloeq"&&(ue.textContent=Mt),Je.forEach(o),i.forEach(o),ke=r(e),f(G.$$.fragment,e),Ie=r(e),c=s(e,"DIV",{class:!0});var C=y(c);f(z.$$.fragment,C),tt=r(C),ce=s(C,"P",{"data-svelte-h":!0}),p(ce)!=="svelte-1fdxdjn"&&(ce.textContent=Pt),at=r(C),T=s(C,"DIV",{class:!0});var H=y(T);f(R.$$.fragment,H),rt=r(H),me=s(H,"P",{"data-svelte-h":!0}),p(me)!=="svelte-950rwb"&&(me.textContent=jt),nt=r(H),fe=s(H,"P",{"data-svelte-h":!0}),p(fe)!=="svelte-1nnxg1l"&&(fe.textContent=kt),st=r(H),ge=s(H,"P",{"data-svelte-h":!0}),p(ge)!=="svelte-1vxxy19"&&(ge.textContent=It),H.forEach(o),ot=r(C),P=s(C,"DIV",{class:!0});var we=y(P);f(X.$$.fragment,we),lt=r(we),he=s(we,"P",{"data-svelte-h":!0}),p(he)!=="svelte-2or2k8"&&(he.textContent=Dt),dt=r(we),_e=s(we,"P",{"data-svelte-h":!0}),p(_e)!=="svelte-ujp0ui"&&(_e.textContent=Ut),we.forEach(o),it=r(C),j=s(C,"DIV",{class:!0});var Ce=y(j);f(Y.$$.fragment,Ce),pt=r(Ce),be=s(Ce,"P",{"data-svelte-h":!0}),p(be)!=="svelte-6rdpda"&&(be.textContent=Et),ut=r(Ce),$e=s(Ce,"P",{"data-svelte-h":!0}),p($e)!=="svelte-dptqqh"&&($e.textContent=Ht),Ce.forEach(o),ct=r(C),w=s(C,"DIV",{class:!0});var V=y(w);f(K.$$.fragment,V),mt=r(V),ve=s(V,"P",{"data-svelte-h":!0}),p(ve)!=="svelte-8teaja"&&(ve.textContent=Vt),ft=r(V),ye=s(V,"P",{"data-svelte-h":!0}),p(ye)!=="svelte-1uc1qrl"&&(ye.textContent=Jt),gt=r(V),f(E.$$.fragment,V),V.forEach(o),C.forEach(o),De=r(e),f(O.$$.fragment,e),Ue=r(e),Be=s(e,"P",{}),y(Be).forEach(o),this.h()},h(){x(u,"name","hf:doc:metadata"),x(u,"content",Xt),x(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,d){t(document.head,u),v(e,k,d),v(e,$,d),v(e,ee,d),g(J,e,d),v(e,Me,d),v(e,A,d),v(e,Pe,d),g(q,e,d),v(e,je,d),v(e,l,d),g(N,l,null),t(l,Ae),t(l,te),t(l,qe),t(l,ae),t(l,Ne),t(l,re),t(l,Se),t(l,ne),t(l,We),t(l,I),g(S,I,null),t(I,Fe),t(I,se),t(l,Ze),t(l,D),g(W,D,null),t(D,Qe),t(D,oe),t(l,Ge),t(l,L),g(F,L,null),t(L,ze),t(L,le),t(L,Re),t(L,de),t(l,Xe),t(l,M),g(Z,M,null),t(M,Ye),t(M,ie),t(M,Ke),t(M,pe),t(l,Oe),t(l,U),g(Q,U,null),t(U,et),t(U,ue),v(e,ke,d),g(G,e,d),v(e,Ie,d),v(e,c,d),g(z,c,null),t(c,tt),t(c,ce),t(c,at),t(c,T),g(R,T,null),t(T,rt),t(T,me),t(T,nt),t(T,fe),t(T,st),t(T,ge),t(c,ot),t(c,P),g(X,P,null),t(P,lt),t(P,he),t(P,dt),t(P,_e),t(c,it),t(c,j),g(Y,j,null),t(j,pt),t(j,be),t(j,ut),t(j,$e),t(c,ct),t(c,w),g(K,w,null),t(w,mt),t(w,ve),t(w,ft),t(w,ye),t(w,gt),g(E,w,null),v(e,De,d),g(O,e,d),v(e,Ue,d),v(e,Be,d),Ee=!0},p(e,[d]){const i={};d&2&&(i.$$scope={dirty:d,ctx:e}),E.$set(i)},i(e){Ee||(h(J.$$.fragment,e),h(q.$$.fragment,e),h(N.$$.fragment,e),h(S.$$.fragment,e),h(W.$$.fragment,e),h(F.$$.fragment,e),h(Z.$$.fragment,e),h(Q.$$.fragment,e),h(G.$$.fragment,e),h(z.$$.fragment,e),h(R.$$.fragment,e),h(X.$$.fragment,e),h(Y.$$.fragment,e),h(K.$$.fragment,e),h(E.$$.fragment,e),h(O.$$.fragment,e),Ee=!0)},o(e){_(J.$$.fragment,e),_(q.$$.fragment,e),_(N.$$.fragment,e),_(S.$$.fragment,e),_(W.$$.fragment,e),_(F.$$.fragment,e),_(Z.$$.fragment,e),_(Q.$$.fragment,e),_(G.$$.fragment,e),_(z.$$.fragment,e),_(R.$$.fragment,e),_(X.$$.fragment,e),_(Y.$$.fragment,e),_(K.$$.fragment,e),_(E.$$.fragment,e),_(O.$$.fragment,e),Ee=!1},d(e){e&&(o(k),o($),o(ee),o(Me),o(A),o(Pe),o(je),o(l),o(ke),o(Ie),o(c),o(De),o(Ue),o(Be)),o(u),b(J,e),b(q,e),b(N),b(S),b(W),b(F),b(Z),b(Q),b(G,e),b(z),b(R),b(X),b(Y),b(K),b(E),b(O,e)}}}const Xt='{"title":"Tuners","local":"tuners","sections":[{"title":"BaseTuner","local":"peft.tuners.tuners_utils.BaseTuner","sections":[],"depth":2},{"title":"BaseTunerLayer","local":"peft.tuners.tuners_utils.BaseTunerLayer","sections":[],"depth":2}],"depth":1}';function Yt(Le){return qt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class na extends St{constructor(u){super(),Wt(this,u,Yt,Rt,At,{})}}export{na as component};
